﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Inspired.Euler.Tests
{
    /// <summary>
    /// Tests for problems from 70 to 79
    /// </summary>
    [TestClass]
    public class Problems070To079
    {
        [TestMethod]
        [Description("Investigate values of <var>n</var> for which &#966;(<var>n</var>) is a permutation of <var>n</var>.")]
        public void Problem070()
        {
            Assert.AreEqual(-1, Euler.Problem070.Solve());
        }

        [TestMethod]
        [Description("Listing reduced proper fractions in ascending order of size.")]
        public void Problem071()
        {
            Assert.AreEqual(-1, Euler.Problem071.Solve());
        }

        [TestMethod]
        [Description("How many elements would be contained in the set of reduced proper fractions for <i>d</i> &le; 1,000,000?")]
        public void Problem072()
        {
            Assert.AreEqual(-1, Euler.Problem072.Solve());
        }

        [TestMethod]
        [Description("How many fractions lie between 1/3 and 1/2 in a sorted set of reduced proper fractions?")]
        public void Problem073()
        {
            Assert.AreEqual(-1, Euler.Problem073.Solve());
        }

        [TestMethod]
        [Description("Determine the number of factorial chains that contain exactly sixty non-repeating terms.")]
        public void Problem074()
        {
            Assert.AreEqual(-1, Euler.Problem074.Solve());
        }

        [TestMethod]
        [Description("Find the number of different lengths of wire can that can form a right angle triangle in only one way.")]
        public void Problem075()
        {
            Assert.AreEqual(-1, Euler.Problem075.Solve());
        }

        [TestMethod]
        [Description("How many different ways can one hundred be written as a sum of at least two positive integers?")]
        public void Problem076()
        {
            Assert.AreEqual(-1, Euler.Problem076.Solve());
        }

        [TestMethod]
        [Description("What is the first value which can be written as the sum of primes in over five thousand different ways?")]
        public void Problem077()
        {
            Assert.AreEqual(-1, Euler.Problem077.Solve());
        }

        [TestMethod]
        [Description("Investigating the number of ways in which coins can be separated into piles.")]
        public void Problem078()
        {
            Assert.AreEqual(-1, Euler.Problem078.Solve());
        }

        [TestMethod]
        [Description("By analysing a user's login attempts, can you determine the secret numeric passcode?")]
        public void Problem079()
        {
            Assert.AreEqual(-1, Euler.Problem079.Solve());
        }
    }
}
