﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Inspired.Euler.Tests
{
    /// <summary>
    /// Tests for problems from 80 to 89
    /// </summary>
    [TestClass]
    public class Problems080To089
    {
        [TestMethod]
        [Description("Calculating the digital sum of the decimal digits of irrational square roots.")]
        public void Problem080()
        {
            Assert.AreEqual(-1, Euler.Problem080.Solve());
        }

        [TestMethod]
        [Description("Find the minimal path sum from the top left to the bottom right by moving right and down.")]
        public void Problem081()
        {
            Assert.AreEqual(-1, Euler.Problem081.Solve());
        }

        [TestMethod]
        [Description("Find the minimal path sum from the left column to the right column.")]
        public void Problem082()
        {
            Assert.AreEqual(-1, Euler.Problem082.Solve());
        }

        [TestMethod]
        [Description("Find the minimal path sum from the top left to the bottom right by moving left, right, up, and down.")]
        public void Problem083()
        {
            Assert.AreEqual(-1, Euler.Problem083.Solve());
        }

        [TestMethod]
        [Description("In the game, Monopoly, find the three most popular squares when using two 4-sided dice.")]
        public void Problem084()
        {
            Assert.AreEqual(-1, Euler.Problem084.Solve());
        }

        [TestMethod]
        [Description("Investigating the number of rectangles in a rectangular grid.")]
        public void Problem085()
        {
            Assert.AreEqual(-1, Euler.Problem085.Solve());
        }

        [TestMethod]
        [Description("Exploring the shortest path from one corner of a cuboid to another.")]
        public void Problem086()
        {
            Assert.AreEqual(-1, Euler.Problem086.Solve());
        }

        [TestMethod]
        [Description("Investigating numbers that can be expressed as the sum of a prime square, cube, and fourth power?")]
        public void Problem087()
        {
            Assert.AreEqual(-1, Euler.Problem087.Solve());
        }

        [TestMethod]
        [Description("Exploring minimal product-sum numbers for sets of different sizes.")]
        public void Problem088()
        {
            Assert.AreEqual(-1, Euler.Problem088.Solve());
        }

        [TestMethod]
        [Description("Develop a method to express Roman numerals in minimal form.")]
        public void Problem089()
        {
            Assert.AreEqual(-1, Euler.Problem089.Solve());
        }
    }
}
