﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Inspired.Euler.Tests
{
    /// <summary>
    /// Tests for problems from 90 to 99
    /// </summary>
    [TestClass]
    public class Problems090To099
    {
        [TestMethod]
        [Description("An unexpected way of using two cubes to make a square.")]
        public void Problem090()
        {
            Assert.AreEqual(-1, Euler.Problem090.Solve());
        }

        [TestMethod]
        [Description("Find the number of right angle triangles in the quadrant.")]
        public void Problem091()
        {
            Assert.AreEqual(-1, Euler.Problem091.Solve());
        }

        [TestMethod]
        [Description("Investigating a square digits number chain with a surprising property.")]
        public void Problem092()
        {
            Assert.AreEqual(-1, Euler.Problem092.Solve());
        }

        [TestMethod]
        [Description("Using four distinct digits and the rules of arithmetic, find the longest sequence of target numbers.")]
        public void Problem093()
        {
            Assert.AreEqual(-1, Euler.Problem093.Solve());
        }

        [TestMethod]
        [Description("Investigating almost equilateral triangles with integral sides and area.")]
        public void Problem094()
        {
            Assert.AreEqual(-1, Euler.Problem094.Solve());
        }

        [TestMethod]
        [Description("Find the smallest member of the longest amicable chain with no element exceeding one million.")]
        public void Problem095()
        {
            Assert.AreEqual(-1, Euler.Problem095.Solve());
        }

        [TestMethod]
        [Description("Devise an algorithm for solving Su Doku puzzles.")]
        public void Problem096()
        {
            Assert.AreEqual(-1, Euler.Problem096.Solve());
        }

        [TestMethod]
        [Description("Find the last ten digits of the non-Mersenne prime: 28433 &times; 2<sup>7830457</sup> + 1.")]
        public void Problem097()
        {
            Assert.AreEqual(-1, Euler.Problem097.Solve());
        }

        [TestMethod]
        [Description("Investigating words, and their anagrams, which can represent square numbers.")]
        public void Problem098()
        {
            Assert.AreEqual(-1, Euler.Problem098.Solve());
        }

        [TestMethod]
        [Description("Which base/exponent pair in the file has the greatest numerical value?")]
        public void Problem099()
        {
            Assert.AreEqual(-1, Euler.Problem099.Solve());
        }
    }
}
