﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Inspired.Euler.Tests
{
    /// <summary>
    /// Tests for problems from 100 to 109
    /// </summary>
    [TestClass]
    public class Problems100To109
    {
        [TestMethod]
        [Description("Finding the number of blue discs for which there is 50% chance of taking two blue.")]
        public void Problem100()
        {
            Assert.AreEqual(-1, Euler.Problem100.Solve());
        }

        [TestMethod]
        [Description("Investigate the optimum polynomial function to model the first <i>k</i> terms of a given sequence.")]
        public void Problem101()
        {
            Assert.AreEqual(-1, Euler.Problem101.Solve());
        }

        [TestMethod]
        [Description("For how many triangles in the text file does the interior contain the origin?")]
        public void Problem102()
        {
            Assert.AreEqual(-1, Euler.Problem102.Solve());
        }

        [TestMethod]
        [Description("Investigating sets with a special subset sum property.")]
        public void Problem103()
        {
            Assert.AreEqual(-1, Euler.Problem103.Solve());
        }

        [TestMethod]
        [Description("Finding Fibonacci numbers for which the first and last nine digits are pandigital.")]
        public void Problem104()
        {
            Assert.AreEqual(-1, Euler.Problem104.Solve());
        }

        [TestMethod]
        [Description("Find the sum of the special sum sets in the file.")]
        public void Problem105()
        {
            Assert.AreEqual(-1, Euler.Problem105.Solve());
        }

        [TestMethod]
        [Description("Find the minimum number of comparisons needed to identify special sum sets.")]
        public void Problem106()
        {
            Assert.AreEqual(-1, Euler.Problem106.Solve());
        }

        [TestMethod]
        [Description("Determining the most efficient way to connect the network.")]
        public void Problem107()
        {
            Assert.AreEqual(-1, Euler.Problem107.Solve());
        }

        [TestMethod]
        [Description("Solving the Diophantine equation 1/<var>x</var> + 1/<var>y</var> = 1/<var>n</var>.")]
        public void Problem108()
        {
            Assert.AreEqual(-1, Euler.Problem108.Solve());
        }

        [TestMethod]
        [Description("How many distinct ways can a player checkout in the game of darts with a score of less than 100?")]
        public void Problem109()
        {
            Assert.AreEqual(-1, Euler.Problem109.Solve());
        }
    }
}
