﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Inspired.Euler.Tests
{
    /// <summary>
    /// Tests for problems from 140 to 149
    /// </summary>
    [TestClass]
    public class Problems140To149
    {
        [TestMethod]
        [Description("Investigating the value of infinite polynomial series for which the coefficients are a linear second order recurrence relation.")]
        public void Problem140()
        {
            Assert.AreEqual(-1, Euler.Problem140.Solve());
        }

        [TestMethod]
        [Description("Investigating progressive numbers, <i>n</i>, which are also square.")]
        public void Problem141()
        {
            Assert.AreEqual(-1, Euler.Problem141.Solve());
        }

        [TestMethod]
        [Description("Perfect Square Collection")]
        public void Problem142()
        {
            Assert.AreEqual(-1, Euler.Problem142.Solve());
        }

        [TestMethod]
        [Description("Investigating the Torricelli point of a triangle ")]
        public void Problem143()
        {
            Assert.AreEqual(-1, Euler.Problem143.Solve());
        }

        [TestMethod]
        [Description("Investigating multiple reflections of a laser beam. ")]
        public void Problem144()
        {
            Assert.AreEqual(-1, Euler.Problem144.Solve());
        }

        [TestMethod]
        [Description("How many reversible numbers are there below one-billion?")]
        public void Problem145()
        {
            Assert.AreEqual(-1, Euler.Problem145.Solve());
        }

        [TestMethod]
        [Description("Investigating a Prime Pattern ")]
        public void Problem146()
        {
            Assert.AreEqual(-1, Euler.Problem146.Solve());
        }

        [TestMethod]
        [Description("Rectangles in cross-hatched grids")]
        public void Problem147()
        {
            Assert.AreEqual(-1, Euler.Problem147.Solve());
        }

        [TestMethod]
        [Description("Exploring Pascal's triangle.")]
        public void Problem148()
        {
            Assert.AreEqual(-1, Euler.Problem148.Solve());
        }

        [TestMethod]
        [Description("Searching for a maximum-sum subsequence.")]
        public void Problem149()
        {
            Assert.AreEqual(-1, Euler.Problem149.Solve());
        }
    }
}
