﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Inspired.Euler.Tests
{
    /// <summary>
    /// Tests for problems from 170 to 179
    /// </summary>
    [TestClass]
    public class Problems170To179
    {
        [TestMethod]
        [Description("Find the largest 0 to 9 pandigital that can be formed by concatenating products.")]
        public void Problem170()
        {
            Assert.AreEqual(-1, Euler.Problem170.Solve());
        }

        [TestMethod]
        [Description("Finding numbers for which the sum of the squares of the digits is a square.")]
        public void Problem171()
        {
            Assert.AreEqual(-1, Euler.Problem171.Solve());
        }

        [TestMethod]
        [Description("Investigating numbers with few repeated digits.")]
        public void Problem172()
        {
            Assert.AreEqual(-1, Euler.Problem172.Solve());
        }

        [TestMethod]
        [Description("Using up to one million tiles how many different 'hollow' square laminae can be formed?")]
        public void Problem173()
        {
            Assert.AreEqual(-1, Euler.Problem173.Solve());
        }

        [TestMethod]
        [Description("Counting the number of 'hollow' square laminae that can form one, two, three, ... distinct arrangements.")]
        public void Problem174()
        {
            Assert.AreEqual(-1, Euler.Problem174.Solve());
        }

        [TestMethod]
        [Description("Fractions involving the number of different ways a number can be expressed as a sum of powers of 2. ")]
        public void Problem175()
        {
            Assert.AreEqual(-1, Euler.Problem175.Solve());
        }

        [TestMethod]
        [Description("Rectangular triangles that share a cathetus.")]
        public void Problem176()
        {
            Assert.AreEqual(-1, Euler.Problem176.Solve());
        }

        [TestMethod]
        [Description("Integer angled Quadrilaterals.")]
        public void Problem177()
        {
            Assert.AreEqual(-1, Euler.Problem177.Solve());
        }

        [TestMethod]
        [Description("Step Numbers")]
        public void Problem178()
        {
            Assert.AreEqual(-1, Euler.Problem178.Solve());
        }

        [TestMethod]
        [Description("Consecutive positive divisors")]
        public void Problem179()
        {
            Assert.AreEqual(-1, Euler.Problem179.Solve());
        }
    }
}
