﻿using System;

namespace Inspired.Euler
{
    /// <summary>
    /// Each new term in the Fibonacci sequence is generated by adding the previous two terms. 
    /// By starting with 1 and 2, the first 10 terms will be:
    /// 
    /// 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, ...
    /// 
    /// Find the sum of all the even-valued terms in the sequence which do not exceed four million.
    /// </summary>
    public static class Problem002
    {
        /// <summary>
        /// Find the sum of all the even-valued terms in the Fibonacci sequence which do not exceed four million.
        /// </summary>
        [EulerProblem(2, Title = "Find the sum of all the even-valued terms in the Fibonacci sequence which do not exceed four million.")]
        public static long Solve()
        {
            int limit = 4000000;
            //Extensions.Fibonacci()
            //    .TakeWhile(number => number < limit)
            //    .Where(number => number % 2 == 0)
            //    .Sum()
            //    .DisplayAndPause();
            
            int x = 1;
            int y = 1;
            int z = 0; // aux
        	int sum = 0;
        	while (sum < limit)
            {
        		sum += (x + y);
                z = x;
                x = x + (2 * y);
                y = (2 * z) + (3 * y);
            }
            return sum;
        }

        static int F(int n)
        {
            return n <= 2 ? 1 : F(n - 1) + F(n - 2);
        }
    }
}
